using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.IO;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Data.OleDb;
using System.Text;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Web.UI.WebControls.Tools;
using Syncfusion.Web.UI.WebControls.Grid.Grouping;

public partial class Default : System.Web.UI.Page
{
    private void Page_Init(object sender, System.EventArgs e)
    {
        this.AccessDataSource1.DataFile = Server.MapPath("\\Syncfusion\\Web\\Data\\OutlookDB.mdb");

        //Here we define the GridGrouping Controls before callback script event.
        //What the below script does is that if the user clicked on the "Move Selection" bar button/Nextpage/previousPage then it will cancel's the Grid's callback
        // (continueCallback = false will do that) and instead invoke the multiplexer's doCallback method.

        //you can use this script to find the action that trigger the callbcak at client side in a alert message.
        //this.InboxGrid.BeforeCallbackScript = "test(arg);";

        //Eg. of selection and next page alone for using as a 'BeforeCallbackScript'
        //this.InboxGrid.BeforeCallbackScript = "if(arg.indexOf('MOVETO:RR:')!=-1){this.continueCallback = false;__sfCallbackMultiplexer1.doCallback('InboxGrid', arg);}else if( arg.indexOf('NEXTPAGE:BB:')!=-1 && (arg.indexOf('5') != -1)){this.continueCallback = false;__sfCallbackMultiplexer2.doCallback('InboxGrid', arg);}";
       
        //see the 'GetBeforeCallbackScript' where we specified the script for selection, nextpage and previous page.
        this.InboxGrid.BeforeCallbackScript = this.GetBeforeCallbackScript();
        
        GridTableDescriptor mainTD = this.InboxGrid.TableDescriptor;
        mainTD.PrimaryKeyColumns.Add("Id");
        this.InboxGrid.DataBind();
        this.InboxGrid.Table.ExpandAllGroups();
        this.InboxGrid.PageSize = 6;
        this.InboxGrid.Table.SelectedRecords.Clear();
    }

    public string GetBeforeCallbackScript()
    {
        StringBuilder sb = new StringBuilder();
        //appending the string for the selection.
        sb.Append("if(arg.indexOf('MOVETO:RR:')!=-1){this.continueCallback = false;__sfCallbackMultiplexer1.doCallback('InboxGrid', arg);}");
        //appeniding for case when the action happened to callback is by NextPage button click , see here we trigger for CallbackMultiplexer2.
        sb.Append("else if( arg.indexOf('NEXTPAGE:BB:')!=-1 && (arg.indexOf('5') != -1)){this.continueCallback = false;__sfCallbackMultiplexer2.doCallback('InboxGrid', arg);}");
        //Appending the string for 'PreviousPage', see hree we trigger the callback for CallbackMultiplexer2
        sb.Append("else if(arg.indexOf('PREVPAGE:BB:')!=-1) {this.continueCallback = false;__sfCallbackMultiplexer3.doCallback('InboxGrid', arg);}");
        //
        sb.Append("else if(arg.indexOf('FIRST:BB:')!=-1) {this.continueCallback = false;__sfCallbackMultiplexer4.doCallback('InboxGrid', arg);}");
        //
        sb.Append("else if(arg.indexOf('LAST:BB:')!=-1) {this.continueCallback = false;__sfCallbackMultiplexer5.doCallback('InboxGrid', arg);}");

        return sb.ToString();

    }

    protected void InboxGrid_SelectedRecordsChanged(object sender, SelectedRecordsChangedEventArgs e)
    {
        //We get the current element       
        Element el = e.Table.CurrentElement;
        //Getting the record from the current element.
        if (el == null)
            return;
        Record rd = el.GetRecord();
        //Checking for records
        if (rd == null)
            return;

        string Contents1;
        // Get the currently selected record From the Inbox Grid.
        Contents1 = rd.GetValue("Sender").ToString();
       if (e.Action == SelectedRecordsChangedType.Added || e.Action == SelectedRecordsChangedType.Reset)
        {
            //Updating the Label with the information from the record.
            lblName.Text = Contents1;
           try
            {
                this.CallbackMultiplexer1.ControlsToRefresh.Add(this.CallbackPanel1);
            }
            catch
            {

            }
        }


    }
    //Triggers  when a button bar item is clicked
    protected void InboxGrid_BarButtonItemClicked(object source, ButtonBarItemClickEventArgs e)
    {
        if (e.ButtonBarItem.ButtonBarItemType == ButtonBarItemType.MoveNextPage)
        {
            try
            {
                this.CallbackMultiplexer2.ControlsToRefresh.Add(this.CallbackPanel1);
            }
            catch
            {

            }
        }
        if (e.ButtonBarItem.ButtonBarItemType == ButtonBarItemType.MovePrevPage)
        {
            try
            {
                this.CallbackMultiplexer3.ControlsToRefresh.Add(this.CallbackPanel1);
            }
            catch
            {

            }
        }
        if (e.ButtonBarItem.ButtonBarItemType == ButtonBarItemType.MoveFirst)
        {
            try
            {
                this.CallbackMultiplexer4.ControlsToRefresh.Add(this.CallbackPanel1);
            }
            catch
            {

            }
         }
         if (e.ButtonBarItem.ButtonBarItemType == ButtonBarItemType.MoveLast)
         {
             try
             {
                 this.CallbackMultiplexer5.ControlsToRefresh.Add(this.CallbackPanel1);
             }
             catch
             {

             }

         }

    }
   
}